//=============================================================================
//
// file :         PLCesallClass.h
//
// description :  Include for the PLCesallClass root class.
//                This class is represents the singleton class for
//                the PLCesall device class.
//                It contains all properties and methods which the 
//                PLCesall requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: graziano $
//
// $Revision: 1.1 $
//
// $Log: PLCesallClass.h,v $
// Revision 1.1  2010-11-23 11:01:23  graziano
// development
//
//
//
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _PLCESALLCLASS_H
#define _PLCESALLCLASS_H

#include <tango.h>
#include <PLCesall.h>


namespace PLCesall_ns
{//=====================================
//	Define classes for attributes
//=====================================
class Real_systemAttrib: public Tango::SpectrumAttr
{
public:
	Real_systemAttrib():SpectrumAttr("Real_system", Tango::DEV_DOUBLE, Tango::READ, MESG_REAL_SYS_LEN) {};
	~Real_systemAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_Real_system(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_Real_system_allowed(ty);}
};

class Out_systemAttrib: public Tango::SpectrumAttr
{
public:
	Out_systemAttrib():SpectrumAttr("Out_system", Tango::DEV_BOOLEAN, Tango::READ, MESG_OUT_SYS_LEN) {};
	~Out_systemAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_Out_system(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_Out_system_allowed(ty);}
};

class Alarm_systemAttrib: public Tango::SpectrumAttr
{
public:
	Alarm_systemAttrib():SpectrumAttr("Alarm_system", Tango::DEV_BOOLEAN, Tango::READ, MESG_ALM_SYS_LEN) {};
	~Alarm_systemAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_Alarm_system(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_Alarm_system_allowed(ty);}
};

class Db_alarmAttrib: public Tango::SpectrumAttr
{
public:
	Db_alarmAttrib():SpectrumAttr("Db_alarm", Tango::DEV_DOUBLE, Tango::READ_WRITE, MESG_ALM_SYS_LEN) {};
	~Db_alarmAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_Db_alarm(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PLCesall *>(dev))->write_Db_alarm(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_Db_alarm_allowed(ty);}
};

class Stat_systemAttrib: public Tango::SpectrumAttr
{
public:
	Stat_systemAttrib():SpectrumAttr("Stat_system", Tango::DEV_BOOLEAN, Tango::READ, MESG_STAT_SYS_LEN) {};
	~Stat_systemAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_Stat_system(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_Stat_system_allowed(ty);}
};

class LogStateAttrib: public Tango::Attr
{
public:
	LogStateAttrib():Attr("LogState", Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~LogStateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_LogState(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PLCesall *>(dev))->write_LogState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_LogState_allowed(ty);}
};

class Plc_statusAttrib: public Tango::Attr
{
public:
	Plc_statusAttrib():Attr("Plc_status", Tango::DEV_BOOLEAN, Tango::READ) {};
	~Plc_statusAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PLCesall *>(dev))->read_Plc_status(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PLCesall *>(dev))->is_Plc_status_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class UpdateDBDescriptionClass : public Tango::Command
{
public:
        UpdateDBDescriptionClass(const char   *name,
                       Tango::CmdArgType in,
                                   Tango::CmdArgType out,
                                   const char        *in_desc,
                                   const char        *out_desc,
                                   Tango::DispLevel  level)
        :Command(name,in,out,in_desc,out_desc, level)   {};

        UpdateDBDescriptionClass(const char   *name,
                       Tango::CmdArgType in,
                                   Tango::CmdArgType out)
        :Command(name,in,out)   {};
        ~UpdateDBDescriptionClass() {};

        virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
        virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
        {return (static_cast<PLCesall *>(dev))->is_UpdateDBDescription_allowed(any);}
};


class AcknowledgeClass : public Tango::Command
{
public:
	AcknowledgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AcknowledgeClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AcknowledgeClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCesall *>(dev))->is_Acknowledge_allowed(any);}
};



class Send_cmdClass : public Tango::Command
{
public:
	Send_cmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Send_cmdClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Send_cmdClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PLCesall *>(dev))->is_Send_cmd_allowed(any);}
};



//
// The PLCesallClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	PLCesallClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static PLCesallClass *init(const char *);
	static PLCesallClass *instance();
	~PLCesallClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	PLCesallClass(string &);
	static PLCesallClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace PLCesall_ns

#endif // _PLCPFELLCLASS_H
