/*
 * plclgthread.h
 *
 *	06.07.2010 - GZS: heartbeat
 */ 

#ifndef PLCLGTHREAD_H
#define PLCLGTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <signal.h>
#include <netdb.h>    
#include "PLCesall.h"

#define SRV_BUF_LEN 2048
#define TIMEADJUST_DEF_H 3
#define TIMEADJUST_DEF_M 5


//############# DB ############
//#define LOG_DB_NAME			"intlkfermi"
//######## ALARM_DESC ########
#define DESC_TABLE_NAME			"vac_mag_desc"
#define DESC_COL_ID_DESCRIPTION	"id_vac_mag_desc"
#define DESC_COL_ID_BYTE		"byte"
#define DESC_COL_ID_BIT			"bit"
#define DESC_COL_PLC			"plc"
#define DESC_COL_NAME			"name"
#define DESC_COL_COMMENT		"comment"
//######## ALARM_STATUS #######
/*#define STAT_TABLE_NAME		"alarm"
#define STAT_COL_TIMESTAMP	"timestamp"
#define STAT_COL_EVENT		"event"
#define STAT_COL_DESC_ID	DESC_COL_ID_DESCRIPTION*/
//######## REAL_TIME #######
#define RT_TABLE_NAME		"vac_mag"
#define RT_COL_TIMESTAMP	"timestamp"
#define RT_COL_EVENT		"event"
#define RT_COL_DESC_ID		DESC_COL_ID_DESCRIPTION

#define VAL_ID_DESCRIPTION_ACK_0		-1	//for acknowledge and srv restart LINAC
#define VAL_ID_DESCRIPTION_ACK_1		-2	//for acknowledge and srv restart UH
#define VAL_ID_DESCRIPTION_ACK_2		-3	//for acknowledge and srv restart PADRES
#define VAL_ID_DESCRIPTION_RESTART_0	-4	//for acknowledge and srv restart LINAC
#define VAL_ID_DESCRIPTION_RESTART_1	-5	//for acknowledge and srv restart UH
#define VAL_ID_DESCRIPTION_RESTART_2	-6	//for acknowledge and srv restart PADRES
#define VAL_ID_INVALID			-1	//for id_byte,id_bit,id_mod of acknowledge and srv restart
#define VAL_COMMENT_ACK			"Sent Acknowledge"	//for acknowledge
#define VAL_COMMENT_RESTART		"Tango Server restarted"	//for acknowledge


//mask for operation on single bits
#define MASK_BIT0     0x0001
#define MASK_BIT1     0x0002
#define MASK_BIT2     0x0004
#define MASK_BIT3     0x0008
#define MASK_BIT4     0x0010
#define MASK_BIT5     0x0020
#define MASK_BIT6     0x0040
#define MASK_BIT7     0x0080
#define MASK_BIT8     0x0100
#define MASK_BIT9     0x0200
#define MASK_BIT10     0x0400
#define MASK_BIT11     0x0800
#define MASK_BIT12     0x1000
#define MASK_BIT13     0x2000
#define MASK_BIT14     0x4000
#define MASK_BIT15     0x8000

static int maskbits[] = {
	MASK_BIT0, 
	MASK_BIT1, 
	MASK_BIT2, 
	MASK_BIT3, 
	MASK_BIT4, 
	MASK_BIT5, 
	MASK_BIT6, 
	MASK_BIT7, 
	MASK_BIT8, 
	MASK_BIT9, 
	MASK_BIT10, 
	MASK_BIT11, 
	MASK_BIT12, 
	MASK_BIT13, 
	MASK_BIT14, 
	MASK_BIT15
};

namespace PLCesall_ns{
	
class log_list : public omni_mutex {
	public:
		log_list(void): empty(this) {}
		~log_list(void) {}
		void push_back(timest_vect& a);
		const timest_vect pop_front(void);
		void clear(void);
		list<timest_vect> show(void);
	protected:
		list<timest_vect> l_log;
	private:
		omni_condition 	empty;
};

class plclgthread : public omni_thread, public Tango::LogAdapter
{	
	private:
		/*PLCesall_ns::*/PLCesall *t_PLCesall;		
				
	public:
		
		//plclgthread(PLCesall_ns::PLCesall::PLCesall *s):Tango::LogAdapter(s){ t_PLCesall = s;};
		//plclgthread(PLCesall_ns::PLCesall::PLCesall *s):Tango::LogAdapter(s);
		
		//~plclgthread(){};
		
		plclgthread(/*PLCesall_ns::*/PLCesall *s):Tango::LogAdapter(s){
			t_PLCesall = s;
		};
		
		~plclgthread() {
		};
		
		log_list raw_list;
		
//		void *StartUndetached(){
//			start_undetached();
//		}
//		void *run_undetached(void *);	
					
	protected:
	
//   		int retval;
//   		int id;
		bool f_log;
		bool f_log_rt;
		PLCesall_ns::intlck_dbalmsys lastmsg;
		PLCesall_ns::intlck_dbalmsys lastmsg_rt;
		PLCesall_ns::timest_vect l;
		
		void run(void *);	
		void log_alarm(void);
		void log_to_db(int, double, int id_plc, int byte_idx, int bit_idx, int id_cmd = -1, int id_fel = -1);
		void update_descr();
		//uint16_t plc_swap(uint16_t in);
		int calc_id_description(int id_plc, int byte_idx, int bit_idx);
		int calc_id_description_cmd(int id_plc, int id_cmd, int id_fel);
		int find_alarmed(double tstamp, int byte_idx, int bit_idx);
		int find_rt_alarmed(double tstamp, int byte_idx, int bit_idx);
				
};	/* end class plclgthread() */

}//	namespace 

#endif

/* EOF */
